<?php

/**
 * tiquete actions.
 *
 * @package    controlComisiones
 * @subpackage tiquete
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tiqueteActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_TIQUETE_V',
        'COM_COMISION',
        'PROYECTOS',
        'TIPOS_COMISION',
        'AREA',
        'COM_TIPO_DESTINO',
        'COM_TERCERO',
        'COM_TIPO_COMISIONADO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_TIQUETE_V'
        )
        , 'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'AREA' =>
        array(
            'id_area' => 'COM_COMISION'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'id_tipo_destino' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_TIQUETE_V'
        ),
        'COM_TIPO_COMISIONADO' =>
        array(
            'tipter' => 'COM_TERCERO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_TIQUETE_V' =>
        array(
            'id_tiquete' => 'id_tiquete',
            'id_comision' => 'id_comision',
            'id_tercero' => 'id_tercero',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'fecha_hora_ini' => 'fecha_hora_ini',
            'fecha_hora_fin' => 'fecha_hora_fin',
            'valor_tiquete' => 'valor_tiquete'
        )
        ,
        'COM_COMISION' =>
        array(
            'id_anhos' => 'id_anhos',
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_tipo_destino' => 'id_tipo_destino',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'id_area' => 'id_area',
            'id_tipo_comision' => 'id_tipo_comision',
            'id_original' => 'id_original',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'activo' => 'activo'
        )
        ,
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'tipo_comision'
        ),
        'AREA' =>
        array(
            'descripcion' => 'area'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'descripcion' => 'tipo_destino'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'email' => 'email'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_TIQUETE_V' =>
        array(
            'id_tiquete,a' => array('!=' => array(-1)),
            'id_tiquete,b' => array('=' => array('id_tiquete')),
            'id_comision' => array('=' => array('id_comision')),
            'id_tercero' => array('=' => array('id_tercero')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => array('=' => array('num_doc'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_tiquete'; //identificador de la tabla
    protected $id_names = array('id_tiquete'); //llave primaria
    protected $field_names = array('id_comision', 'id_tercero', 'fecha_ini', 'fecha_fin', 'valor_tiquete'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_TIQUETE'; //tabla en la cual se aplican los cambios 
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla
    /*
     * campos para fecha sistema con hora
     */
    protected $campo_fecha_sistema_hora = array(
            //'fecha_ini', 'fecha_fin'
    );
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_tiquete'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


        }

        //accion update
        if ($Action == "UPDATE") {

            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {


            $id_tiquete = $request['id_tiquete'];


            $sql = <<<EOD
select * from com_tiquete  where id_tiquete = $id_tiquete
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_comision = $records[0]['id_comision'];
            $id_tercero = $records[0]['id_tercero'];

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $sql = <<<EOD
select * from objetos_gasto  where ano_fiscal = '$id_anhos' and viaje = 1
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_obj_gasto = $records[0]['id'];

            $logger->info("Objeto de Gasto " . $id_obj_gasto);

            $sql = <<<EOD
delete from COM_COMISIONADO_OBJ  where id_comision=$id_comision and id_tercero = $id_tercero 
    and ID_OBJ_GASTO = (select id from objetos_gasto  where ano_fiscal = '$id_anhos' and viaje = 1)  and observaciones = 'VALOR CORRESPONDIENTE A TIQUETES'
EOD;


            CN_TABLE::executeSQL($sql);
        }
        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {


        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;


        $id_comision = $request['id_comision'];
        $id_tercero = $request['id_tercero'];

        $fecha_ini = $request['fecha_ini'];
        $fecha_fin = $request['fecha_fin'];
        
        $valor_tiquete=$request['valor_tiquete'];

        $fecha_salida = $fecha_ini;
        $fecha_regreso = $fecha_fin;

        $hora_ini = $request['hora_ini'];
        $hora_fin = $request['hora_fin'];

        $request['fecha_ini'] = $fecha_ini . " " . $hora_ini;
        $request['fecha_fin'] = $fecha_fin . " " . $hora_fin;

        $logger->info("fecha_ini :: " . $request['fecha_ini']);
        $logger->info("fecha_fin :: " . $request['fecha_fin']);


        $sql = <<<EOD
select count(id_comisionado) cantidad from com_comisionado where id_comision = $id_comision and id_tercero = $id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];


        if ($cantidad == 0) {

            $errors['mensaje'] = "El Comisionado no se encuentra programado en esta comision, no se puede asociar el tiquete";
            $errors['servicio'] = "tiquete";
        }


        $sql = <<<EOD
select 
case when to_date('$fecha_regreso','YYYY-MM-DD') < to_date('$fecha_salida','YYYY-MM-DD') THEN 1
WHEN to_date('$fecha_salida','YYYY-MM-DD') < trunc(sysdate) then 2
WHEN to_date('$fecha_regreso','YYYY-MM-DD') < trunc(sysdate) then 3
else 0
end as VALIDA
from com_comisionado tab0
    where tab0.id_comision = $id_comision and tab0.id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);


        $valida = $records[0]['valida'];


        if ($valida == 1) {

            $errors['mensaje'] = "La fecha de regreso no debe ser posterior a la fecha de salida";
            $errors['servicio'] = "tiquete";
        }

        //20181119
        if ($valida == 2) {

            $errors['mensaje'] = "La fecha de salida no debe ser inferior a la fecha actual";
            $errors['servicio'] = "tiquete";
        }

        if ($valida == 3) {

            $errors['mensaje'] = "La fecha de regreso no debe ser inferior a la fecha actual";
            $errors['servicio'] = "tiquete";
        }
        //VALIDAR QUE LA FECHA SE ENCUENTRE EN EL RANGO DE FECHAS DEL COMISIONADO
        //20170526 Validamos que con la compra del tiquete no se exceda el presupuesto del area para tiquetes
        //si no existe registro de presupuesto o el presupuesto es 0 para la vigencia y departamento se omite esta validacion
        
        $sql = <<<EOD
select 
*
from com_estado_presup_tiquetes_v tab0
    where id_area=(select id_area from com_comision where id_comision=$id_comision) 
    and vigencia=(select id_anhos from com_comision where id_comision=$id_comision)
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if(count($records)>0){
            //capturamos valores del estado del presupuesto
            $presupuesto=$records[0]['presupuesto'];
            $gastado=$records[0]['gastos_tiquetes'];
            $saldo=$records[0]['saldo'];
            if(($saldo-$valor_tiquete)<0 && $presupuesto>0){
                $errors['mensaje'] = "El presupuesto restante de la dependencia no es suficiente para el tiquete.";
                $errors['servicio'] = "tiquete";
            }
        }

        //20170530 se valida que la comision no tenga cuenta para poder registrar nuevos tiquetes
        $sql = <<<EOD
select cc.* from com_cuenta cc join com_resolucion cr on cc.ID_RESOLUCION=cr.ID_RESOLUCION where cr.id_comision= $id_comision and cc.estado<>0
EOD;

        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {
            //20191031 Se omite validacion de cuenta Ticket #14333
            //$errors['mensaje'] = "La comision ya posee una cuenta asociada, No se pueden programar tiquetes";
            //$errors['servicio'] = "tiquete";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        
        
        $id_tiquete=$request['id_tiquete'];
        /*
         *  Validar la operación, ya sea por SQL
         */
        //20170530 se valida que la comision no tenga cuenta para poder eliminar los tiquetes ya existentes
        $sql = <<<EOD
SELECT cc.*
FROM com_cuenta cc
JOIN com_resolucion cr
ON cc.ID_RESOLUCION =cr.ID_RESOLUCION
JOIN com_comision comis on comis.ID_COMISION=cr.ID_COMISION
join com_tiquete ct on ct.ID_COMISION=comis.ID_COMISION
WHERE ct.id_tiquete= $id_tiquete and cc.estado<>0
EOD;

        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {

            $errors['mensaje'] = "La comision ya posee una cuenta asociada, No se pueden eliminar tiquetes";
            $errors['servicio'] = "tiquete";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {


        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;


        $id_comision = $request['id_comision'];
        $id_tercero = $request['id_tercero'];

        $fecha_ini = $request['fecha_ini'];
        $fecha_fin = $request['fecha_fin'];

        $fecha_salida = $fecha_ini;
        $fecha_regreso = $fecha_fin;

        $hora_ini = $request['hora_ini'];
        $hora_fin = $request['hora_fin'];

        $request['fecha_ini'] = $fecha_ini . " " . $hora_ini;
        $request['fecha_fin'] = $fecha_fin . " " . $hora_fin;
        
        $logger->info("fecha_ini :: " . $request['fecha_ini']);
        $logger->info("fecha_fin :: " . $request['fecha_fin']);
        //Quitamos las variables qe no son editables como fecha y comisionado
        //unset($request['fecha_ini']);
        //unset($request['fecha_fin']);
        //unset($request['id_tercero']);

        $sql = <<<EOD
select count(id_comisionado) cantidad from com_comisionado where id_comision = $id_comision and id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];


        if ($cantidad == 0) {

            $errors['mensaje'] = "El Comisionado no se encuentra programado en esta comision, no se puede asociar el tiquete";
            $errors['servicio'] = "tiquete";
        }

        //20181119 Se quita validacion de fecha al actualizar ya que solo se permite cambiar el valor
        
    /*    $sql = <<<EOD
select 
case when to_date('$fecha_regreso','YYYY-MM-DD') < to_date('$fecha_salida','YYYY-MM-DD') THEN 1
WHEN to_date('$fecha_salida','YYYY-MM-DD') < trunc(sysdate) then 2
WHEN to_date('$fecha_regreso','YYYY-MM-DD') < trunc(sysdate) then 3
WHEN to_date('$fecha_salida','YYYY-MM-DD') not between trunc(fecha_salida) and trunc(fecha_regreso) then 4
WHEN to_date('$fecha_regreso','YYYY-MM-DD') not between trunc(fecha_salida) and trunc(fecha_regreso) then 5
else 0
end as VALIDA
from com_comisionado tab0
    where tab0.id_comision = $id_comision and tab0.id_tercero=$id_tercero
EOD;

        $records = CN_TABLE::executeSQL($sql);


        $valida = $records[0]['valida'];


        if ($valida == 1) {

            $errors['mensaje'] = "La fecha de regreso no debe ser posterior a la fecha de salida";
            $errors['servicio'] = "tiquete";
        }

        if ($valida == 2) {

            $errors['mensaje'] = "La fecha de salida no debe ser inferior a la fecha actual";
            $errors['servicio'] = "tiquete";
        }

        if ($valida == 3) {

            $errors['mensaje'] = "La fecha de regreso no debe ser inferior a la fecha actual";
            $errors['servicio'] = "tiquete";
        }

        if ($valida == 4) {

            $errors['mensaje'] = "La fecha de salida no se encuentra en el rango de fechas de la comision";
            $errors['servicio'] = "tiquete";
        }

        if ($valida == 5) {

            $errors['mensaje'] = "La fecha de regreso no se encuentra en el rango de fechas de la comision";
            $errors['servicio'] = "tiquete";
        }*/



        //VALIDAR QUE LA FECHA SE ENCUENTRE EN EL RANGO DE FECHAS DEL COMISIONADO


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Metodo para add tiquete
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("[sfAPIActions] ---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            if ($value == 'null') {
                unset($request[$key]);
            }
        }
        $this->logMessage("[sfAPIActions] --------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("[sfAPIActions] ---END Logging request");

        /**
         * VALIDAR ERRORES DE PROCEDIMIENTO
         */
        try {

            // Validar operación
            $errors = $this->validateAdd($request);

            /*
             * Validar errors
             */
            if ($errors == null) {

                /**
                 * Acciones anteriores a la original
                 * 
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $request = $this->preprocessRequest("ADD", $request);


                // Ejecutar la operación normalmente        
                $this->add($request);

                /**
                 * Acciones posteriores a la original
                 * 
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $this->postprocessRequest("ADD", $request, $this->list_data);
            } else {

                /*
                 * Validar que errors es un array con datos
                 */
                if (is_array($errors)) {
                    $errors['operacion'] = "ADD";
                    $this->list_errors = $errors;
                }

                // Devolver los errores vía Json
                if (isset($errors['mensaje'])) {
                    $mensaje = "[ADD tiquete] " . $errors['mensaje'];
                } else {
                    $mensaje = "[ADD tiquete] ERROR !!!";
                }


                $this->logMessage($mensaje);
                $this->logMessage("status -1");

                $this->status = $this->STATUS_FAILURE;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
            }
        } catch (Doctrine_Connection_Exception $e) {

            $mensaje = "[ADD tiquete] ERROR Doctrine_Connection_Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        } catch (Exception $e) {

            $mensaje = "[ADD tiquete] ERROR Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'operacion' => "ADD"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        }
    }

    /**
     * Insert de tiquete
     * @param sfWebRequest $request
     */
    public function add(sfWebRequest $request) {

        //manejo de errores
        try {

            //variables obligatorias
            $id_comision = $request['id_comision'];
            $id_tercero = $request['id_tercero'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $valor_tiquete = $request['valor_tiquete'];


            //sentencia sql ingresar CA_DEBITO
            $sql = <<<EOD
INSERT INTO COM_TIQUETE (id_tiquete, id_comision, id_tercero, 
    fecha_ini, fecha_fin, valor_tiquete) 
        VALUES (null, $id_comision, $id_tercero, 
            to_Date('$fecha_ini', 'YYYY-MM-DD HH:MI AM'), 
            to_Date('$fecha_fin', 'YYYY-MM-DD HH:MI AM'), 
                    $valor_tiquete) 
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);

            //resultado del debito anulado
            $resultado[] = array(
                'id_comision' => $id_comision,
                'id_tercero' => $id_tercero,
                'fecha_ini' => $fecha_ini,
                'fecha_fin' => $fecha_fin,
                'valor_tiquete' => $valor_tiquete
            );

            $this->list_data = $resultado;
            $this->logMessage("Se cre tiquete");
        } catch (Exception $ex) {
            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Actualiza una fila por los parametros de entrada
     *
     * @param sfWebRequest $request
     */
    public function executeUpdate(sfWebRequest $request) {

//Revisar que sea post
//$this->forward404Unless($request->isMethod('post'));
//Guardar los parametros del request en el log
        $this->logMessage("[sfAPIActions] ---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            if ($value == 'null') {
                unset($request[$key]);
            }
        }
        $this->logMessage("[sfAPIActions] --------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("[sfAPIActions] ---END Logging request");

        /**
         * VALIDAR ERRORES DE PROCEDIMIENTO
         */
        try {

            // Validar operación
            $errors = $this->validateUpdate($request);

            /*
             * Validar errors
             */
            if ($errors == null) {

                /**
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $request = $this->preprocessRequest("UPDATE", $request);
                
                // Ejecutar la operación normalmente        
                $this->update($request);

                /**
                 * Acciones posteriores a la original
                 * 
                 * return sfWebRequest Changed Request with additional parameters.
                 */
                $this->postprocessRequest("UPDATE", $request, $this->list_data);
            } else {

                /*
                 * Validar que errors es un array con datos
                 */
                if (is_array($errors)) {
                    $errors['operacion'] = "UPDATE";
                    $this->list_errors = $errors;
                }

                // Devolver los errores vía Json
                if (isset($errors['mensaje'])) {
                    $mensaje = "[UPDATE tiquete] " . $errors['mensaje'];
                } else {
                    $mensaje = "[UPDATE tiquete] ERROR !!!";
                }

                $this->logMessage($mensaje);
                $this->logMessage("status -1");

                $this->status = $this->STATUS_FAILURE;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
            }
        } catch (Doctrine_Connection_Exception $e) {

            $mensaje = "[UPDATE tiquete] ERROR Doctrine_Connection_Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'mensaje' => $mensaje,
                'operacion' => "UPDATE"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        } catch (Exception $e) {

            $mensaje = "[UPDATE tiquete] ERROR Exception !!!";


            $this->list_errors = array(
                'Code' => $e->getCode(),
                'Message' => $e->getMessage(),
                'Line' => $e->getLine(),
                'Trace' => $e->getTraceAsString(),
                'mensaje' => $mensaje,
                'operacion' => "UPDATE"
            );

            $this->logMessage($mensaje);
            $this->logMessage("status -1");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = $this->STATUS_FAILURE;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
        }
    }

    /**
     * Insert de tiquete
     * @param sfWebRequest $request
     */
    public function update(sfWebRequest $request) {

        //manejo de errores
        try {

            //variables obligatorias
            $id_tiquete = $request['id_tiquete'];
            $id_comision = $request['id_comision'];
            $id_tercero = $request['id_tercero'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $valor_tiquete = $request['valor_tiquete'];


            //sentencia sql ingresar CA_DEBITO
            $sql = <<<EOD
update com_tiquete set 
    id_tercero = $id_tercero,
    fecha_ini = to_Date('$fecha_ini', 'YYYY-MM-DD HH:MI AM'),
    fecha_fin = to_Date('$fecha_fin', 'YYYY-MM-DD HH:MI AM') , 
    valor_tiquete = $valor_tiquete                 
    where id_tiquete = $id_tiquete 
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);

            //resultado del debito anulado
            $resultado[] = array(
                'id_tiquete' => $id_tiquete,
                'id_comision' => $id_comision,
                'id_tercero' => $id_tercero,
                'fecha_ini' => $fecha_ini,
                'fecha_fin' => $fecha_fin,
                'valor_tiquete' => $valor_tiquete
            );

            $this->list_data = $resultado;
            $this->logMessage("Se cre tiquete");
        } catch (Exception $ex) {
            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($ex->getMessage());
        }
    }

}
